﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EventTest
{
    public class Hero
    {

        // описание события
        public event HealthChangedHandler HealthChanged;

        // описание делагата для подписывающихся на событие функци
        public delegate void HealthChangedHandler(object sender, EventArgs eventArgs);

        // описание события
        public event HealthChangedPlusHandler HealthChangedPlus;

        // описание делагата для подписывающихся на событие функци
        public delegate void HealthChangedPlusHandler(object sender, HealthChangedArgs healthChangedArgs);


        private int _health = 100;
        public int Health
        {
            get
            {
                return _health;
            }
            set
            {
                _health = value;
                if (HealthChanged != null)
                {
                    EventArgs eventArgs = new EventArgs();
                    HealthChanged(this, eventArgs);

                    // второй вариант события, в котором обработчику передаются параметры
                    HealthChangedArgs healthChangedArgs = new HealthChangedArgs(_health);
                    HealthChangedPlus(this, healthChangedArgs);
                }
            }
        }

        // end public class Hero
    }

    public class HealthChangedArgs : EventArgs
    {
        private int _health = 0;

        public int Health
        {
            get { return _health; }
        }

        public HealthChangedArgs(int health)
        {
            _health = health;
        }

    }

}
